package com.fzm.mall.server.admin.order.entity.dto;

import lombok.Data;

import java.math.BigDecimal;

@Data
public class TranDto {

    /**
     * 提货订单
     */
    public static final Integer TABLE_TYPE_DELIVERY = 1;

    /**
     * 商品订单
     */
    public static final Integer TABLE_TYPE_ORDER_INFO = 2;

    public static final Integer COIN_TYPE_NFT_OUT = 1;

    public static final Integer COIN_TYPE_NFT_IN = 2;

    private Integer id;

    private String hash;

    private String fromAddr;

    private String toAddr;

    private BigDecimal amount;

    private String coin;

    /**
     * 业务id
     */
    private String tableId;

    /**
     * 业务类型，1:提货订单；2.商品订单
     */
    private Integer tableType;

    private Long tokenId;

    /**
     * 1.外部nft;2.内部nft；3.内部普通
     */
    private Integer coinType;
}
