package com.fzm.mall.server.front.asset.model.vo.asset;

import com.fzm.mall.server.front.goods.model.vo.SkuVo;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;

@Data
public class UserAssetVo {
    private Long id;
    @ApiModelProperty("资产类型(0、支付币 1、商品币）")
    private Integer type;
    private String page;
    private String size;
    private String uid;
    @ApiModelProperty("币名称")
    private String coin;
    @ApiModelProperty("冻结数量")
    private BigDecimal frozen;
    @ApiModelProperty("可用数量")
    private BigDecimal amount;
    @ApiModelProperty("用户资产地址")
    private String address;
    @ApiModelProperty("商品币信息")
    private SkuVo skuVo;
    @ApiModelProperty("记录类型(1、转账 2、收款）不传查全部")
    private Integer dealType;
    @ApiModelProperty("币种logo")
    private String logo;
    @ApiModelProperty("关键字查询")
    private String keyWord;

}
